<?php
function site_counter()
{
  static $counter;
  static $default;
  $ipaddr = array();

  $today = getdate();
  if (! isset($default))
    $default = array(
      'total'     => 0,
      'date'      => get_date('Y/m/d'),
      'time'      => (int)($today['hours'] / 6),
      'today'     => 0,
      'yesterday' => 0);

  if (isset($counter)) return $counter;

  // Set default
  $counter = $default;
  $modify  = FALSE;

  $file = COUNTER_DIR . 'site_counter.dat';
  $fp = fopen($file, file_exists($file) ? 'r+' : 'w+')
    or die('site_counter.php: Cannot open COUTER_DIR/' . basename($file));
  set_file_buffer($fp, 0);
  flock($fp, LOCK_EX);
  rewind($fp);
  foreach ($default as $key=>$val) {
    // Update
    $counter[$key] = rtrim(fgets($fp, 256));
    if (feof($fp)) break;
  }
  while(!feof($fp)){
    $ipaddr[] = rtrim(fgets($fp, 256));
  }

  if ($counter['date'] != $default['date']) {
    // New day
    $modify = TRUE;
    $is_yesterday = ($counter['date'] == get_date('Y/m/d', strtotime('yesterday', UTIME)));
    $ipaddr               = array($_SERVER['REMOTE_ADDR']);
    $counter['date']      = $default['date'];
    $counter['time']      = $default['time'];
    //$counter['yesterday'] = $is_yesterday ? $counter['today'] : 0;
    $counter['yesterday'] = $counter['today'];
    $counter['today']     = 1;
    $counter['total']++;
  }else{
    $newaccess = TRUE;
    if($counter['time'] != $default['time']){
      $ipaddr = array();
      $counter['time']  = $default['time'];
    }else{
      foreach($ipaddr as $ip){
        if ($ip == $_SERVER['REMOTE_ADDR']){
          $newaccess = FALSE;
          break;
        }
      }
    }
    if ($newaccess) {
      // Not the same host
      $modify = TRUE;
      $ipaddr[] = $_SERVER['REMOTE_ADDR'];
      $counter['today']++;
      $counter['total']++;
    }
  }
  // Modify
  if ($modify) {
    rewind($fp);
    ftruncate($fp, 0);
    foreach (array_keys($default) as $key)
      fputs($fp, $counter[$key] . "\n");
    foreach($ipaddr as $ip)
      if($ip != '')
        fputs($fp, $ip . "\n");
  }
  flock($fp, LOCK_UN);
  fclose($fp);

  return $counter;
}
?>
